<?php

/**
 * @version     1.0.0
 * @package     com_resonlinebooking
 * @copyright   Copyright (C) 2014. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      binhk32xp <binhk32xp@gmail.com> - http://eku.com
 */
// No direct access
defined('_JEXEC') or die;

jimport('joomla.application.component.view');

/**
 * View class for a list of Resonlinebooking.
 */
class ResonlinebookingViewBookinglist extends JViewLegacy {

    protected $items;
    protected $pagination;
    protected $state;

    /**
     * Display the view
     */
    public function display($tpl = null) {
        $this->state = $this->get('State');
        $this->items = $this->get('Items');
        $this->pagination = $this->get('Pagination');

        // Check for errors.
        if (count($errors = $this->get('Errors'))) {
            throw new Exception(implode("\n", $errors));
        }

        ResonlinebookingHelper::addSubmenu('bookinglist');

        $this->addToolbar();

        $this->sidebar = JHtmlSidebar::render();
        parent::display($tpl);
    }

    /**
     * Add the page title and toolbar.
     *
     * @since	1.6
     */
    protected function addToolbar() {
        require_once JPATH_COMPONENT . '/helpers/resonlinebooking.php';

        $state = $this->get('State');
        $canDo = ResonlinebookingHelper::getActions($state->get('filter.category_id'));

        JToolBarHelper::title(JText::_('COM_RESONLINEBOOKING_TITLE_BOOKINGLIST'), 'bookinglist.png');

        //Check if the form exists before showing the add/edit buttons
        $formPath = JPATH_COMPONENT_ADMINISTRATOR . '/views/bookingedit';
        if (file_exists($formPath)) {

            if ($canDo->get('core.create')) {
                JToolBarHelper::addNew('bookingedit.add', 'JTOOLBAR_NEW');
            }

            if ($canDo->get('core.edit') && isset($this->items[0])) {
                JToolBarHelper::editList('bookingedit.edit', 'JTOOLBAR_EDIT');
            }
        }

        if ($canDo->get('core.edit.state')) {

            if (isset($this->items[0]->state)) {
                JToolBarHelper::divider();
                JToolBarHelper::custom('bookinglist.publish', 'publish.png', 'publish_f2.png', 'JTOOLBAR_PUBLISH', true);
                JToolBarHelper::custom('bookinglist.unpublish', 'unpublish.png', 'unpublish_f2.png', 'JTOOLBAR_UNPUBLISH', true);
            } else if (isset($this->items[0])) {
                //If this component does not use state then show a direct delete button as we can not trash
                JToolBarHelper::deleteList('', 'bookinglist.delete', 'JTOOLBAR_DELETE');
            }

            if (isset($this->items[0]->state)) {
                JToolBarHelper::divider();
                JToolBarHelper::archiveList('bookinglist.archive', 'JTOOLBAR_ARCHIVE');
            }
            if (isset($this->items[0]->checked_out)) {
                JToolBarHelper::custom('bookinglist.checkin', 'checkin.png', 'checkin_f2.png', 'JTOOLBAR_CHECKIN', true);
            }
        }

        //Show trash and delete for components that uses the state field
        if (isset($this->items[0]->state)) {
            if ($state->get('filter.state') == -2 && $canDo->get('core.delete')) {
                JToolBarHelper::deleteList('', 'bookinglist.delete', 'JTOOLBAR_EMPTY_TRASH');
                JToolBarHelper::divider();
            } else if ($canDo->get('core.edit.state')) {
                JToolBarHelper::trash('bookinglist.trash', 'JTOOLBAR_TRASH');
                JToolBarHelper::divider();
            }
        }

        if ($canDo->get('core.admin')) {
            JToolBarHelper::preferences('com_resonlinebooking');
        }

        //Set sidebar action - New in 3.0
        JHtmlSidebar::setAction('index.php?option=com_resonlinebooking&view=bookinglist');

        $this->extra_sidebar = '';
        
    }

	protected function getSortFields()
	{
		return array(
		'a.bookingname' => JText::_('COM_RESONLINEBOOKING_BOOKINGLIST_BOOKINGNAME'),
		'a.hotelid' => JText::_('COM_RESONLINEBOOKING_BOOKINGLIST_HOTELID'),
		'a.defaultadults' => JText::_('COM_RESONLINEBOOKING_BOOKINGLIST_DEFAULTADULTS'),
		'a.defaultnights' => JText::_('COM_RESONLINEBOOKING_BOOKINGLIST_DEFAULTNIGHTS'),
		'a.defaultchildren' => JText::_('COM_RESONLINEBOOKING_BOOKINGLIST_DEFAULTCHILDREN'),
		'a.maxchildren' => JText::_('COM_RESONLINEBOOKING_BOOKINGLIST_MAXCHILDREN'),
		'a.maxadults' => JText::_('COM_RESONLINEBOOKING_BOOKINGLIST_MAXADULTS'),
		);
	}

}
